MODULE DfConfigEdit;

  IMPORT SYSTEM, Kernel, Files, Strings, Log, DfConfig, DfUtils;

  PROCEDURE Main;
    VAR i: INTEGER;
    VAR t: DfUtils.Text; loc: Files.Locator; dir, name: Files.Name;
    VAR c: DfConfig.Config; s: DfConfig.Section; k: DfConfig.Key;
    VAR s0, s1: ARRAY 32 OF CHAR;
  BEGIN
    IF Kernel.trapCount # 0 THEN Kernel.Quit(1) END;
    i := 0;
    WHILE i < Kernel.argc DO
      IF Kernel.argv[i, 0] # "-" THEN
        DfUtils.SplitPath(Kernel.argv[i]$, dir, name);
        loc := Files.dir.This(dir);
        t := DfUtils.ReadText(loc, name);
        IF t = NIL THEN
          Log.ParamMsg("^0: unable to open file '^1' '^2'", Kernel.argv[0]$, dir, name); Log.Ln;
          Kernel.Quit(1)
        END;
        c := DfConfig.Parse(t);
        IF c = NIL THEN
          Log.ParamMsg("^0: invalid config '^1' '^2'", Kernel.argv[0]$, dir, name); Log.Ln;
          Kernel.Quit(1)
        END;
        INC(i)
      ELSIF Kernel.argv[i]$ = "-new" THEN
        c := DfConfig.New();
        INC(i)
      ELSIF Kernel.argv[i]$ = "-dump" THEN
        IF c = NIL THEN
          Log.ParamMsg("^0: config not opened", Kernel.argv[0]$, "", ""); Log.Ln;
          Kernel.Quit(1)
        END;
        s := c.sections;
        WHILE s # NIL DO
          Log.Char("["); Log.String(s.name); Log.Char("]"); Log.Ln;
          k := s.keys;
          WHILE k # NIL DO
            Log.String(k.name); Log.Char("="); Log.String(k.value); Log.Ln;
            k := k.next
          END;
          Log.Ln;
          s := s.next
        END;
        INC(i)
      ELSIF Kernel.argv[i]$ = "-res" THEN
        Strings.IntToString(c.res, s0);
        Strings.IntToString(c.pos, s1);
        Log.ParamMsg("(res = ^0, pos = ^1)", s0, s1, ""); Log.Ln;
        INC(i)
      ELSE
        Log.ParamMsg("^0: unknown option ^1", Kernel.argv[0]$, Kernel.argv[i]$, ""); Log.Ln;
        Kernel.Quit(1)
      END
    END;
    Kernel.Quit(0)
  END Main;

BEGIN
  Kernel.Start(Main)
END DfConfigEdit.
