MODULE DfUtils;

  IMPORT SYSTEM, Kernel, Files;

  TYPE
    Text* = POINTER TO ARRAY OF CHAR;

  PROCEDURE SplitPath* (IN path: ARRAY OF CHAR; OUT dir, name: Files.Name);
    VAR i, j, len: INTEGER;
  BEGIN
    len := LEN(path$);
    i := len - 1;
    WHILE (i >= 0) & (path[i] # '/') DO DEC(i) END;
    IF i >= 0 THEN
      FOR i := 0 TO i - 1 DO
        dir[i] := path[i]
      END;
      dir[i] := 0X
    ELSE
      dir := ""
    END;
    j := i + 1; i := 0;
    WHILE path[j] # 0X DO
      name[i] := path[j];
      INC(i); INC(j)
    END;
    name[i] := 0X
  END SplitPath;

  PROCEDURE ReadText* (loc: Files.Locator; IN name: Files.Name): Text;
    TYPE SText = POINTER TO ARRAY OF SHORTCHAR;
    TYPE Bytes = POINTER TO ARRAY OF BYTE;
    VAR f: Files.File; r: Files.Reader; x: Bytes; t: Text; len: INTEGER;
  BEGIN
    ASSERT(loc # NIL, 20);
    ASSERT(name # "", 21);
    f := Files.dir.Old(loc, name, Files.shared);
    IF f # NIL THEN
      len := f.Length();
      NEW(x, len + 1);
      r := f.NewReader(NIL);
      r.ReadBytes(x, 0, len);
      x[len] := 0;
      NEW(t, len + 1);
      Kernel.Utf8ToString(SYSTEM.VAL(SText, x), t, loc.res);
      f.Close
    END;
    RETURN t
  END ReadText;

END DfUtils.
