MODULE DswSDLImage;

	IMPORT Kernel, SDL := DswSDL;

	CONST
		(* init flags *)
		jpg* = 0; png* = 1; tif* = 2; webp* = 3;

	TYPE
		Hook* = POINTER TO ABSTRACT RECORD (Kernel.Hook) END;

	VAR
		hook-: Hook;

	PROCEDURE (hook: Hook) WasInit* (flags: SET): SET, NEW, ABSTRACT;

	PROCEDURE (hook: Hook) Load* (IN file: ARRAY OF CHAR): SDL.Surface, NEW, ABSTRACT;
	PROCEDURE (hook: Hook) LoadRW* (src: SDL.RWops; freesrc: BOOLEAN): SDL.Surface, NEW, ABSTRACT;

	PROCEDURE SetHook* (h: Hook);
	BEGIN
		ASSERT(h # NIL, 20);
		hook := h
	END SetHook;

	PROCEDURE WasInit* (flags: SET): SET;
	BEGIN
		ASSERT(hook # NIL, 100);
		RETURN hook.WasInit(flags)
	END WasInit;

	PROCEDURE Load* (IN file: ARRAY OF CHAR): SDL.Surface;
	BEGIN
		ASSERT(hook # NIL, 100);
		RETURN hook.Load(file)
	END Load;

	PROCEDURE LoadRW* (src: SDL.RWops; freesrc: BOOLEAN): SDL.Surface;
	BEGIN
		ASSERT(hook # NIL, 100);
		RETURN hook.LoadRW(src, freesrc)
	END LoadRW;

END DswSDLImage.
