MODULE DswSDLImageLin32;

	IMPORT DswSDL, SImp := DswSDLLin32, SLib := DswSDLLin32Lib,
		DswSDLImage, Lib := DswSDLImageLin32Lib;

	TYPE
		Hook = POINTER TO RECORD (DswSDLImage.Hook) END;
		
	VAR
		flags: SET;
		
	PROCEDURE (hook: Hook) WasInit (mask: SET): SET;
	BEGIN
		RETURN flags * mask
	END WasInit;

	PROCEDURE (hook: Hook) Load (IN file: ARRAY OF CHAR): DswSDL.Surface;
		VAR surf: SLib.Surface;
	BEGIN
		surf := Lib.Load(SHORT(file$));
		RETURN SImp.NewSurface(surf)
	END Load;
	
	PROCEDURE (hook: Hook) LoadRW (src: DswSDL.RWops; freesrc: BOOLEAN): DswSDL.Surface;
		VAR res: INTEGER; ptr: SLib.RWops; surf: SLib.Surface;
	BEGIN
		ASSERT(src # NIL, 20);
		ASSERT(~src.Closed(), 21);
		WITH src: SImp.RWops DO
			ptr := src.GetPtr();
			ASSERT(ptr # NIL, 100);
			IF freesrc THEN res := SLib.True
			ELSE res := SLib.False
			END;
			surf := Lib.Load_RW(ptr, res)
		END;
		RETURN SImp.NewSurface(surf)
	END LoadRW;

	PROCEDURE Init;
		VAR hook: Hook;
	BEGIN
		flags := BITS(Lib.Init(ORD(-{})));
		NEW(hook); DswSDLImage.SetHook(hook)
	END Init;

	PROCEDURE Fin;
	BEGIN
		Lib.Quit
	END Fin;

BEGIN
	Init
CLOSE
	Fin
END DswSDLImageLin32.
