MODULE DswSDLLin32Lib ["libSDL2.so"];

	CONST
		FIRSTEVENT* = 0;
		QUIT* = 100H;
		APP_TERMINATING* = 101H;
		APP_LOWMEMORY* = 102H;
		APP_WILLENTERBACKGROUND* = 103H;
		APP_DIDENTERBACKGROUND* = 104H;
		APP_WILLENTERFOREGROUND* = 105H;
		APP_DIDENTERFOREGROUND* = 106H;
		WINDOWEVENT* = 200H;
		SYSWMEVENT* = 201H;
		KEYDOWN* = 300H;
		KEYUP* = 301H;
		TEXTEDITING* = 302H;
		TEXTINPUT* = 303H;
		KEYMAPCHANGED* = 304H;
		MOUSEMOTION* = 400H;
		MOUSEBUTTONDOWN* = 401H;
		MOUSEBUTTONUP* = 402H;
		MOUSEWHEEL* = 403H;
		JOYAXISMOTION* = 600H;
		JOYBALLMOTION* = 601H;
		JOYHATMOTION* = 602H;
		JOYBUTTONDOWN* = 603H;
		JOYBUTTONUP* = 604H;
		JOYDEVICEADDED* = 605H;
		JOYDEVICEREMOVED* = 606H;
		CONTROLLERAXISMOTION* = 650H;
		CONTROLLERBUTTONDOWN* = 651H;
		CONTROLLERBUTTONUP* = 652H;
		CONTROLLERDEVICEADDED* = 653H;
		CONTROLLERDEVICEREMOVED* = 654H;
		CONTROLLERDEVICEREMAPPED* = 655H;
		FINGERDOWN* = 700H;
		FINGERUP* = 701H;
		FINGERMOTION* = 702H;
		DOLLARGESTURE* = 800H;
		DOLLARRECORD* = 801H;
		MULTIGESTURE* = 802H;
		CLIPBOARDUPDATE* = 900H;
		DROPFILE* = 1000H;
		DROPTEXT* = 1001H;
		DROPBEGIN* = 1002H;
		DROPCOMPLETE* = 1003H;
		AUDIODEVICEADDED* = 1100H;
		AUDIODEVICEREMOVED* = 1101H;
		RENDER_TARGETS_RESET* = 2000H;
		RENDER_DEVICE_RESET* = 2001H;
		USEREVENT* = 8000H;
		LASTEVENT* = 0FFFFH;

		TEXTEDITINGEVENT_TEXT_SIZE* = 32;
		TEXTINPUTEVENT_TEXT_SIZE* = 32;

		WINDOWEVENT_NONE* = 0;
		WINDOWEVENT_SHOWN* = 1;
		WINDOWEVENT_HIDDEN* = 2;
		WINDOWEVENT_EXPOSED* = 3;
		WINDOWEVENT_MOVED* = 4;
		WINDOWEVENT_RESIZED* = 5;
		WINDOWEVENT_SIZE_CHANGED* = 6;
		WINDOWEVENT_MINIMIZED* = 7;
		WINDOWEVENT_MAXIMIZED* = 8;
		WINDOWEVENT_RESTORED* = 9;
		WINDOWEVENT_ENTER* = 10;
		WINDOWEVENT_LEAVE* = 11;
		WINDOWEVENT_FOCUS_GAINED* = 12;
		WINDOWEVENT_FOCUS_LOST* = 13;
		WINDOWEVENT_CLOSE* = 14;
		WINDOWEVENT_TAKE_FOCUS* = 15;
		WINDOWEVENT_HIT_TEST* = 16;

		RWOPS_UNKNOWN* = 0;
		RWOPS_WINFILE* = 1;
		RWOPS_STDFILE* = 2;
		RWOPS_JNIFILE* = 3;
		RWOPS_MEMORY* = 4;
		RWOPS_MEMORY_RO* = 5;

		RW_SEEK_SET* = 0;
		RW_SEEK_CUR* = 1;
		RW_SEEK_END* = 2;
		
		False* = 0;
		True* = 1;

	TYPE
		Int* = INTEGER;
		Long* = INTEGER;
		Uint32* = INTEGER;
		Sint32* = INTEGER;
		Uint8* = BYTE;
		Sint16* = SHORTINT;
		Uint16* = SHORTINT;
		Sint64* = LONGINT;
		Enum* = INTEGER;
		PtrVoid* = INTEGER;
		PtrSTR* = POINTER [untagged] TO STR;
		STR* = ARRAY [untagged] OF SHORTCHAR;
		SizeT* = INTEGER;
		
		ArrUint8* = ARRAY [untagged] OF Uint8;
		PtrArrUint8* = POINTER [untagged] TO ArrUint8;

		Bool* = Enum;
		GLattr* = Enum;
		Keycode* = Sint32;
		Keymod* = Enum;
		Scancode* = Enum;
		JoystickID* = Sint32;
		JoystickType* = Enum;
		TouchID* = Sint64;
		FingerID* = Sint64;
		GestureID* = Sint64;

		Window* = POINTER [untagged] TO WindowDesc;
		WindowDesc = LIMITED RECORD [untagged] END;
		GLContext* = POINTER [untagged] TO GLContextDesc;
		GLContextDesc = LIMITED RECORD [untagged] END;

		Keysym* = RECORD [untagged]
			scancode*: Scancode;
			sym*: Keycode;
			mod*: Uint16;
			unused*: Uint32;
		END;

		EventType* = Enum;
		CommonEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
		END;
		WindowEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			event*, pdding1*, padding2*, padding3*: Uint8;
			data1*, data2*: Sint32;
		END;
		KeyboardEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			state*, repeat*, padding2*, padding3*: Uint8;
			keysym*: Keysym;
		END;
		TextEditingEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			text*: ARRAY TEXTEDITINGEVENT_TEXT_SIZE OF SHORTCHAR;
			start*, length*: Sint32;
		END;
		TextInputEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			text*: ARRAY TEXTINPUTEVENT_TEXT_SIZE OF SHORTCHAR;
		END;
		MouseMotionEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			which*, state*: Uint32;
			x*, y*, xrel*, yrel*: Sint32;
		END;
		MouseButtonEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			which*: Uint32;
			button*, state*, clicks*, padding1*: Uint8;
			x*, y*: Sint32;
		END;
		MouseWheelEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			which*: Uint32;
			x*, y*: Sint32;
			direction*: Uint32;
		END;
		JoyAxisEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: JoystickID;
			axis*, padding1*, padding2*, padding3*: Uint8;
			value*: Sint16;
			padding4*: Uint16;
		END;
		JoyBallEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: JoystickID;
			ball*, padding1*, padding2*, padding3*: Uint8;
			xrel*, yrel*: Sint16;
		END;
		JoyHatEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: JoystickID;
			hat*, value*, padding1*, padding2*: Uint8;
		END;
		JoyButtonEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: JoystickID;
			button*, state*, padding1*, padding2*: Uint8;
		END;
		JoyDeviceEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: Sint32;
		END;
		ControllerAxisEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: JoystickID;
			axis*, padding1*, padding2*, padding3*: Uint8;
			value*: Sint16;
			padding4*: Uint16;
		END;
		ControllerButtonEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: JoystickID;
			button*, state*, padding1*, padding2*: Uint8;
		END;
		ControllerDeviceEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: Sint32;
		END;
		AudioDeviceEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			which*: Uint32;
			iscapture*, padding1*, padding2*, padding3*: Uint8;
		END;
		TouchFingerEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			touchId*: TouchID;
			fingerId*: FingerID;
			x*, y*, dx*, dy*, pressure*: SHORTREAL;
		END;
		MultiGestureEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			touchId*: TouchID;
			dTheta*, dDist*, x*, y*: SHORTREAL;
			numFingers*, padding*: Uint16;
		END;
		DollarGestureEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			touchId*: TouchID;
			gestureId*: GestureID;
			numFingers*: Uint16;
			error*, x*, y*: SHORTREAL;
		END;
		DropEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			file*: PtrSTR;
			windowID*: Uint32;
		END;
		QuitEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
		END;
		OSEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
		END;
		UserEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			windowID*: Uint32;
			code*: Sint32;
			data1*, data2*: PtrVoid;
		END;
		SysWMEvent* = RECORD [untagged]
			type*, timestamp*: Uint32;
			(* msg*: POINTER [untagged] TO SysWMmsg; *)
			msg*: INTEGER;
		END;
		Event* = RECORD [union]
			type*: Uint32;
			common*: CommonEvent;
			window*: WindowEvent;
			key*: KeyboardEvent;
			edit*: TextEditingEvent;
			text*: TextInputEvent;
			motion*: MouseMotionEvent;
			button*: MouseButtonEvent;
			wheel*: MouseWheelEvent;
			jaxis*: JoyAxisEvent;
			jball*: JoyBallEvent;
			jhat*: JoyHatEvent;
			jbutton*: JoyButtonEvent;
			jdevice*: JoyDeviceEvent;
			caxis*: ControllerAxisEvent;
			cbutton*: ControllerButtonEvent;
			cdevice*: ControllerDeviceEvent;
			cadevice*: AudioDeviceEvent;
			quit*: QuitEvent;
			user*: UserEvent;
			syswm*: SysWMEvent;
			tfinger*: TouchFingerEvent;
			mgesture*: MultiGestureEvent;
			dgesture*: DollarGestureEvent;
			drop*: DropEvent;
			padding*: ARRAY 56 OF Uint8;
		END;

		ArrPoint* = ARRAY [untagged] OF Point;
		Point* = RECORD [untagged]
			x*, y*: Int;
		END;
		ArrRect* = ARRAY [untagged] OF Rect;
		Rect* = RECORD [untagged]
			x*, y*: Int;
			w*, h*: Int;
		END;

		PtrArrColor* = POINTER [untagged] TO ArrColor;
		ArrColor* = ARRAY [untagged] OF Color;
		Colour* = Color; (* alias *)
		Color* = RECORD [untagged]
			r*, g*, b*, a*: Uint32;
		END;

		Palette* = POINTER [untagged] TO PaletteDesc;
		PaletteDesc* = LIMITED RECORD [untagged]
			ncolors-: Int;
			colors-: PtrArrColor;
			version-: Uint32;
			refcount-: Int;
		END;

		PixelFormat* = POINTER [untagged] TO PixelFormatDesc;
		PixelFormatDesc* = LIMITED RECORD [untagged]
			format-: Uint32;
			palette-: Palette;
			BitsPerPixel-, BytesPerPixel-: Uint8;
			padding-: ARRAY 2 OF Uint8;
			Rmask-, Gmask-, Bmask-, Amask-: Uint32;
			Rloss-, Gloss-, Bloss-, Aloss-: Uint8;
			Rshift-, Gshift-, Bshift-, Ashift-: Uint8;
			refcount-: Int;
			next-: PixelFormat;
		END;

		BlitMap = POINTER [untagged] TO BlitMapDesc;
		BlitMapDesc = LIMITED RECORD [untagged] END;
		
		Surface* = POINTER [untagged] TO SurfaceDesc;
		SurfaceDesc* = LIMITED RECORD [untagged]
			flags-: Uint32;
			format-: PixelFormat;
			w-, h-, pitch-: Int;
			pixels*, userdata*: PtrVoid;
			locked-: Int;
			lock_data-: PtrVoid;
			clip_rect-: Rect;
			map-: BlitMap;
			refcount*: Int;
		END;

		RWops* = POINTER [untagged] TO RWopsDesc;
		RWopsDesc* = LIMITED RECORD [untagged]
			size*: PROCEDURE [ccall16] (context: RWops): Sint64;
			seek*: PROCEDURE [ccall16] (context: RWops; offset: Sint64; whence: Int): Sint64;
			read*: PROCEDURE [ccall16] (context: RWops; ptr: PtrVoid; size, maxnum: SizeT): SizeT;
			write*: PROCEDURE [ccall16] (context: RWops; ptr: PtrVoid; size, num: SizeT): SizeT;
			close*: PROCEDURE [ccall16] (context: RWops): Int;
			type*: Uint32;
			hidden*: RECORD [union]
				androidio*: RECORD
					fileNameRef*: PtrVoid;
					inputStreamRef*: PtrVoid;
					readableByteChannelRef*: PtrVoid;
					readMethod*: PtrVoid;
					assetFileDescriptorRef*: PtrVoid;
					position*, size*, offset: Long;
					fd*: Int;
				END;
				windowsio*: RECORD
					append*: Bool;
					h*: PtrVoid;
					buffer*: RECORD
						data*: PtrVoid;
						size*, left*: SizeT;
					END;
				END;
				stdio*: RECORD
					autoclose*: Bool;
					fp*: PtrVoid;
				END;
				mem*: RECORD
					base*, here*, stop*: PtrArrUint8;
				END;
				unknown*: RECORD
					data1*, data2*: PtrVoid;
				END;
			END;
		END;

	PROCEDURE [ccall16] Init* ["SDL_Init"] (flags: Uint32): Int;
	PROCEDURE [ccall16] InitSubSystem* ["SDL_InitSubsystem"] (flags: Uint32): Int;
	PROCEDURE [ccall16] QuitSubSystem* ["SDL_QuitSubsystem"] (flags: Uint32): Int;
	PROCEDURE [ccall16] WasInit* ["SDL_WasInit"] (flags: Uint32): Uint32;
	PROCEDURE [ccall16] Quit* ["SDL_Quit"];

	PROCEDURE [ccall16] CreateWindow* ["SDL_CreateWindow"] (IN title: STR; x, y, w, h: Int; flags: Uint32): Window;
	PROCEDURE [ccall16] DestroyWindow* ["SDL_DestroyWindow"] (window: Window);
	PROCEDURE [ccall16] GetWindowID* ["SDL_GetWindowID"] (window: Window): Uint32;
	PROCEDURE [ccall16] SetWindowInputFocus* ["SDL_SetWindowInputFocus"] (window: Window): Int;
	PROCEDURE [ccall16] ShowWindow* ["SDL_ShowWindow"] (window: Window);
	PROCEDURE [ccall16] HideWindow* ["SDL_HideWindow"] (window: Window);

	PROCEDURE [ccall16] Delay* ["SDL_Delay"] (ms: Uint32);

	PROCEDURE [ccall16] GetMouseState* ["SDL_GetMouseState"] (VAR [nil] x, y: Int): SET;
	PROCEDURE [ccall16] StartTextInput* ["SDL_StartTextInput"];
	PROCEDURE [ccall16] StopTextInput* ["SDL_StartTextInput"];

	PROCEDURE [ccall16] PollEvent* ["SDL_PollEvent"] (VAR event: Event): Int;

	PROCEDURE [ccall16] GL_LoadLibrary* ["SDL_GL_LoadLibrary"] (IN path: STR): Int;
	PROCEDURE [ccall16] GL_GetProcAddress* ["SDL_GL_GetProcAddress"] (IN proc: STR): PtrVoid;
	PROCEDURE [ccall16] GL_UnloadLibrary* ["SDL_GL_UnloadLibrary"];
	PROCEDURE [ccall16] GL_ExtensionSupported* ["SDL_GL_ExtensionSupported"] (IN extension: STR): Bool;
	PROCEDURE [ccall16] GL_ResetAttributes* ["SDL_GL_ResetAttributes"];
	PROCEDURE [ccall16] GL_SetAttribute* ["SDL_GL_SetAttribute"] (attr: GLattr; value: Int): Int;
	PROCEDURE [ccall16] GL_GetAttribute* ["SDL_GL_GetAttribute"] (attr: GLattr; VAR value: Int): Int;
	PROCEDURE [ccall16] GL_CreateContext* ["SDL_GL_CreateContext"] (window: Window): GLContext;
	PROCEDURE [ccall16] GL_MakeCurrent* ["SDL_GL_MakeCurrent"] (window: Window; context: GLContext): Int;
	PROCEDURE [ccall16] GL_GetCurrentWindow* ["SDL_GL_GetCurrentWindow"] (): Window;
	PROCEDURE [ccall16] GL_GetCurrentContext* ["SDL_GL_GetCurrentContext"] (): GLContext;
	PROCEDURE [ccall16] GL_GetDrawableSize* ["SDL_GL_GetDrawableSize"] (window: Window; OUT [nil] w, h: Int);
	PROCEDURE [ccall16] GL_SetSwapInterval* ["SDL_GL_SetSwapInterval"] (interval: Int): Int;
	PROCEDURE [ccall16] GL_GetSwapInterval* ["SDL_GL_GetSwapInterval"] (): Int;
	PROCEDURE [ccall16] GL_SwapWindow* ["SDL_GL_SwapWindow"] (window: Window);
	PROCEDURE [ccall16] GL_DeleteContext* ["SDL_GL_DeleteContext"] (context: GLContext);

	PROCEDURE [ccall16] AllocRW* ["SDL_AllocRW"] (): RWops;
	PROCEDURE [ccall16] FreeRW* ["SDL_FreeRW"] (area: RWops);

	PROCEDURE [ccall16] LoadBMP_RW* ["SDL_LoadBMP_RW"] (src: RWops; freesrc: Int): Surface;

(*
	PROCEDURE [ABI] CreateRGBSurfaceWithFormatFrom* ["SDL_CreateRGBSurfaceWithFormatFrom"] (pixels: PtrVoid; width, height, depth, pitch: Int; format: Uint32): Surface;
	
	PROCEDURE [ABI] SaveBMP_RW* ["SDL_SaveBMP_RW"] (surface: Surface; dst: RWops; freedst: Int): Int;
*)
	PROCEDURE [ccall16] ConvertSurfaceFormat* ["SDL_ConvertSurfaceFormat"] (src: Surface; pixel_format: Uint32; flags: Uint32): Surface;
(*
	PROCEDURE [ABI] ConvertPixels* ["SDL_ConvertPixels"] (width, height: Int; src_format: Uint32; src: PtrVoid; src_pitch: Int; dst_format: Uint32; dst: PtrVoid; dst_pitch: Int): Int;
*)

	PROCEDURE [ccall16] FreeSurface* ["SDL_FreeSurface"] (surface: Surface);

END DswSDLLin32Lib.
