#! /bin/bash

set -e

cleanup() {
  rm -rf tmp
}

compile() {
  cpc486 -outcode tmp/code -outsym tmp/sym -legacysymdir runtime "$@"
}

link() {
  local out="$1"; shift
  cpl486 -os linux -main Kernel -kernel Kernel -o "$out" \
    -codedir tmp/code -legacycodedir runtime "$@"
}

if [ "$1" != "" ]; then
  compile -no-ref Dsw/Mod/{GL,GLLin32}.cp
  compile Dsw/Mod/{SDL,SDLLin32Lib,SDLLin32}.cp
  compile Dsw/Mod/{SDLImage,SDLImageLin32Lib,SDLImageLin32}.cp
fi
compile Df/Mod/{Utils,Random,Config,ConfigEdit,ModelEdit}.cp

link ConfigEdit \
  PosixCtypes PosixCmacro Kernel \
  Files Log Math Strings Console Services \
  HostLang HostFiles HostConsole DswLog \
  DfConfig DfUtils DfConfigEdit

link ModelEdit \
  PosixCtypes PosixCmacro Kernel \
  Files Log Math Strings Console Services \
  HostLang HostFiles HostConsole DswLog DswDebug \
  DswSDL DswSDLImage DswGL \
  DswSDLLin32 DswSDLImageLin32 DswGLLin32 \
  DfConfig DfUtils DfRandom DfModelEdit
